#include "DxLib.h"
#include "board.h"
#include "main.h"
#include "gamemain.h"

/////////////////////////////////////////////////////////
//ϐ錾
/////////////////////////////////////////////////////////

//`bv摜i[ϐ
static int m_Chip[4];
//{[hԂi[ϐ
static int m_Board[BOARD_WIDTH][BOARD_HEIGHT];

/////////////////////////////////////////////////////////
//{[h
/////////////////////////////////////////////////////////

void Board_Init(){
	//zu
	int i, j;
	for (i = 0; i < BOARD_WIDTH; i++){
		for (j = 0; j < BOARD_HEIGHT; j++){
			m_Board[i][j] = 0;
		}
	}
	//zu
	m_Board[3][3] = WHITE, m_Board[4][3] = BLACK;
	m_Board[3][4] = BLACK, m_Board[4][4] = WHITE;
	//摜ǂݍ
	LoadDivGraph("img/chip.png", 4, 4, 1, BOARDCHIP_SIZE, BOARDCHIP_SIZE, m_Chip);
}

/////////////////////////////////////////////////////////
//{[hɋu֐(߂l͔]R}̐)
/////////////////////////////////////////////////////////

int Board_Putchip(int x, int y, bool put_flag){
	//ϐ錾
	int flipsum = 0, check_x, check_y, direction_x, direction_y,
		tmp_flip_x[BOARD_WIDTH], tmp_flip_y[BOARD_HEIGHT], count,flipcount;
	//]ItO
	bool flipend;
	//Xe[^XvC  }EXŎwĂW
	if (MainData.status == PLAYING && (m_Board[x][y] == BLACK || m_Board[x][y] == WHITE)){
		return 0;
	}
	//
	for (direction_x = -1; direction_x <= 1; direction_x++){
		for (direction_y = -1; direction_y <= 1; direction_y++){
			//]ItO
			flipend = false;
			//[v(̕ɂЂi)
			for (count = 0;; count++){
				//܂`FbNW
				check_x = x + direction_x * (count + 1);
				check_y = y + direction_y * (count + 1);
				//Ղ̊OuĂȂꍇ̓[v𔲂
				if (check_x < 0 || check_x >= (BOARD_WIDTH ) ||
					check_y < 0 || check_y >= (BOARD_HEIGHT) ||
					m_Board[check_x][check_y] == NONE) break;
				//̋Ăꍇ
				if (m_Board[check_x][check_y] == MainData.turn){
					for (flipcount = 0; flipcount < count; flipcount++){
						if (put_flag){
							m_Board[tmp_flip_x[flipcount]][tmp_flip_y[flipcount]] = MainData.turn;
						}
						flipsum += count;
					}
					//]ItO𗧂Ă
					flipend = true;
				}
				//ꎞϐɊi[
				tmp_flip_x[count] = check_x;
				tmp_flip_y[count] = check_y;
				//]IꍇA̕𑖍
				if (flipend) break;
			}
		}
	}
	//]R}uA^[ςA^[𑝂₷
	if (flipsum > 0){
		if (put_flag){
			m_Board[x][y] = MainData.turn;
			MainData.turn = Game_ChangeTurn();
			MainData.Gamecount++;
		}
		return flipsum;
	}else{
		return 0;
	}
}

/////////////////////////////////////////////////////////
//uꏊɈu֐(߂l͒uꏊ̐)
/////////////////////////////////////////////////////////

int Board_Check(bool show_flag){
	int i, j,put_count = 0;
	for (i = 0; i < BOARD_WIDTH; i++){			//
		for (j = 0; j < BOARD_HEIGHT; j++){		//c
			if ((m_Board[i][j] == 0) && Board_Putchip(i, j, false) > 0){
				if (show_flag){
					DrawGraph(BOARDCHIP_SIZE * i, BOARDCHIP_SIZE * j, m_Chip[3], TRUE);
				}
				put_count++;
			}
		}
	}
	return put_count;
}

/////////////////////////////////////////////////////////
//`֐
/////////////////////////////////////////////////////////

void Board_Draw(){
	int i, j;
	MainData.blackcount = 0, MainData.whitecount = 0;
	for (i = 0; i < BOARD_WIDTH; i++){			//
		for (j = 0; j < BOARD_HEIGHT; j++){		//c
			switch (m_Board[i][j]){
			case NONE:
				DrawGraph(BOARDCHIP_SIZE * i, BOARDCHIP_SIZE * j, m_Chip[0], TRUE);
				break;
			case BLACK:
				MainData.blackcount++;
				DrawGraph(BOARDCHIP_SIZE * i, BOARDCHIP_SIZE * j, m_Chip[1], TRUE);
				break;
			case WHITE:
				MainData.whitecount++;
				DrawGraph(BOARDCHIP_SIZE * i, BOARDCHIP_SIZE * j, m_Chip[2], TRUE);
				break;
			}
		}
	}
}
