﻿#include "DxLib.h"
#include "cpu.h"
#include "board.h" 

//返せるコマの数が置いところにコマを置く
void CPU1(){
	int x, y, check_return, check_max = 0 , CPU_x, CPU_y;
	for (x = 0; x < BOARD_WIDTH; x++){
		for (y = 0; y < BOARD_HEIGHT; y++){
			check_return = Board_Putchip(x, y, false);
			if (check_max < check_return || (check_max == check_return && GetRand(1) == 0)){
				CPU_x = x;
				CPU_y = y;
				check_max = check_return;
			}
		}
	}
	Board_Putchip(CPU_x, CPU_y, true);
}

//盤面評価の結果からコマを置く
void CPU2(){
	int priority[8][8] = {
		{ 0, 6, 2, 1, 1, 2, 6, 0 },
		{ 6, 6, 5, 4, 4, 5, 6, 6 },
		{ 2, 5, 2, 3, 3, 2, 5, 2 },
		{ 1, 4, 3, 3, 3, 3, 4, 1 },
		{ 1, 4, 3, 3, 3, 3, 4, 1 },
		{ 2, 5, 2, 3, 3, 2, 5, 2 },
		{ 6, 6, 5, 4, 4, 5, 6, 6 },
		{ 0, 6, 2, 1, 1, 2, 6, 0 },
	};
	int x, y, check_return, check_max = 0, CPU_x, CPU_y, p;
	for (p = 0; p <= 6 && check_max == 0; p++) {
		for (x = 0; x < BOARD_WIDTH; x++){
			for (y = 0; y < BOARD_HEIGHT; y++){
				if (priority[x][y] != p) continue;
				check_return = Board_Putchip(x, y, false);
				if (check_max < check_return || (check_max == check_return && GetRand(1) == 0)){
					CPU_x = x;
					CPU_y = y;
					check_max = check_return;
				}
			}
		}
	}
	Board_Putchip(CPU_x, CPU_y, true);
}